"enable aexpr";

System.register(['active-expression-rewriting', 'reactive-jsx', 'src/components/halo/lively-halo-item.js', 'src/client/graphics.js', 'src/client/contextmenu.js', './Connection.js'], function (_export, _context) {
  "use strict";

  var _getAndCallMember, _setMember, _setLocal, _getLocal, _getGlobal, _getMember, _traceMember, _childExpression, _children, _attributes, _element, HaloItem, pt, ContextMenu, Connection;

  return {
    setters: [function (_activeExpressionRewriting) {
      _getAndCallMember = _activeExpressionRewriting.getAndCallMember;
      _setMember = _activeExpressionRewriting.setMember;
      _setLocal = _activeExpressionRewriting.setLocal;
      _getLocal = _activeExpressionRewriting.getLocal;
      _getGlobal = _activeExpressionRewriting.getGlobal;
      _getMember = _activeExpressionRewriting.getMember;
      _traceMember = _activeExpressionRewriting.traceMember;
    }, function (_reactiveJsx) {
      _childExpression = _reactiveJsx.childExpression;
      _children = _reactiveJsx.children;
      _attributes = _reactiveJsx.attributes;
      _element = _reactiveJsx.element;
    }, function (_srcComponentsHaloLivelyHaloItemJs) {
      HaloItem = _srcComponentsHaloLivelyHaloItemJs.default;
    }, function (_srcClientGraphicsJs) {
      pt = _srcClientGraphicsJs.pt;
    }, function (_srcClientContextmenuJs) {
      ContextMenu = _srcClientContextmenuJs.default;
    }, function (_ConnectionJs) {
      Connection = _ConnectionJs.default;
    }],
    execute: function () {
      const __SystemJSRewritingHack = {};
      _recorder_._src_components_halo_lively_halo_connectors_item_js = _recorder_._src_components_halo_lively_halo_connectors_item_js || {};
      let _scope = {};
      if (self.__expressionAnalysisMode__) _traceMember(Object, 'defineProperty');
      Object.defineProperty(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('_recorder_') : void 0, _recorder_), '_src_components_halo_lively_halo_connectors_item_js'), 'HaloItem', {
        get() {
          return self.__expressionAnalysisMode__ ? _getLocal(_scope, 'HaloItem', HaloItem) : void 0, HaloItem;
        },

        set(thisIsVererySecretVariableName) {
          let _scope2 = {};
          HaloItem = (self.__expressionAnalysisMode__ ? _getLocal(_scope2, 'thisIsVererySecretVariableName', thisIsVererySecretVariableName) : void 0, thisIsVererySecretVariableName), true ? _setLocal(_scope, 'HaloItem', HaloItem) : void 0, HaloItem;
          return true;
        },

        enumerable: true,
        configurable: true
      });
      if (self.__expressionAnalysisMode__) _traceMember(Object, 'defineProperty');
      Object.defineProperty(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('_recorder_') : void 0, _recorder_), '_src_components_halo_lively_halo_connectors_item_js'), 'pt', {
        get() {
          return self.__expressionAnalysisMode__ ? _getLocal(_scope, 'pt', pt) : void 0, pt;
        },

        set(thisIsVererySecretVariableName) {
          let _scope3 = {};
          pt = (self.__expressionAnalysisMode__ ? _getLocal(_scope3, 'thisIsVererySecretVariableName', thisIsVererySecretVariableName) : void 0, thisIsVererySecretVariableName), true ? _setLocal(_scope, 'pt', pt) : void 0, pt;
          return true;
        },

        enumerable: true,
        configurable: true
      });
      if (self.__expressionAnalysisMode__) _traceMember(Object, 'defineProperty');
      Object.defineProperty(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('_recorder_') : void 0, _recorder_), '_src_components_halo_lively_halo_connectors_item_js'), 'ContextMenu', {
        get() {
          return self.__expressionAnalysisMode__ ? _getLocal(_scope, 'ContextMenu', ContextMenu) : void 0, ContextMenu;
        },

        set(thisIsVererySecretVariableName) {
          let _scope4 = {};
          ContextMenu = (self.__expressionAnalysisMode__ ? _getLocal(_scope4, 'thisIsVererySecretVariableName', thisIsVererySecretVariableName) : void 0, thisIsVererySecretVariableName), true ? _setLocal(_scope, 'ContextMenu', ContextMenu) : void 0, ContextMenu;
          return true;
        },

        enumerable: true,
        configurable: true
      });
      if (self.__expressionAnalysisMode__) _traceMember(Object, 'defineProperty');
      Object.defineProperty(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('_recorder_') : void 0, _recorder_), '_src_components_halo_lively_halo_connectors_item_js'), 'Connection', {
        get() {
          return self.__expressionAnalysisMode__ ? _getLocal(_scope, 'Connection', Connection) : void 0, Connection;
        },

        set(thisIsVererySecretVariableName) {
          let _scope5 = {};
          Connection = (self.__expressionAnalysisMode__ ? _getLocal(_scope5, 'thisIsVererySecretVariableName', thisIsVererySecretVariableName) : void 0, thisIsVererySecretVariableName), true ? _setLocal(_scope, 'Connection', Connection) : void 0, Connection;
          return true;
        },

        enumerable: true,
        configurable: true
      });
      class LivelyHaloConnectorsItem extends HaloItem {

        async initialize() {
          _setMember(this, 'windowTitle', "LivelyHaloConnectorsItem");

          if (self.__expressionAnalysisMode__) _traceMember(this, 'registerEvent');
          this.registerEvent('click', 'onClick');
        }

        onClick(evt) {
          let _scope6 = {};

          _setMember(this, 'source', _getMember((self.__expressionAnalysisMode__ ? _getGlobal('window') : void 0, window), 'that'));

          if (self.__expressionAnalysisMode__) _traceMember(this, 'showStartingConnectorsMenuFor');
          this.showStartingConnectorsMenuFor((self.__expressionAnalysisMode__ ? _getLocal(_scope6, 'evt', evt) : void 0, evt));

          if (self.__expressionAnalysisMode__) _traceMember(this, 'hideHalo');
          this.hideHalo();
        }

        async showMenu(evt, menuItems) {
          let _scope7 = {};

          const menu = await (self.__expressionAnalysisMode__ ? _traceMember(ContextMenu, 'openIn') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope, 'ContextMenu', ContextMenu) : void 0, ContextMenu).openIn(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('document') : void 0, document), 'body'), (self.__expressionAnalysisMode__ ? _getLocal(_scope7, 'evt', evt) : void 0, evt), (self.__expressionAnalysisMode__ ? _getGlobal('undefined') : void 0, undefined), _getMember((self.__expressionAnalysisMode__ ? _getGlobal('document') : void 0, document), 'body'), (self.__expressionAnalysisMode__ ? _getLocal(_scope7, 'menuItems', menuItems) : void 0, menuItems)));
        }

        async showStartingConnectorsMenuFor(evt) {
          let _scope8 = {};


          let connections = [];
          _getAndCallMember(_getMember((self.__expressionAnalysisMode__ ? _getLocal(_scope, 'Connection', Connection) : void 0, Connection), 'allConnections'), 'forEach', [connection => {
            let _scope9 = {};
            if (self.__expressionAnalysisMode__) _traceMember(connections, 'push');

            (self.__expressionAnalysisMode__ ? _getLocal(_scope8, 'connections', connections) : void 0, connections).push((self.__expressionAnalysisMode__ ? _getLocal(_scope9, 'connection', connection) : void 0, connection));
          }]);
          let existingConnectionsMenu = (self.__expressionAnalysisMode__ ? _traceMember(connections, 'map') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope8, 'connections', connections) : void 0, connections).map(connection => {
            let _scope10 = {};
            return [(self.__expressionAnalysisMode__ ? _traceMember(connection, 'getLabel') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope10, 'connection', connection) : void 0, connection).getLabel()), () => {
              return self.__expressionAnalysisMode__ ? _traceMember(this, 'openConnectionEditor') : void 0, this.openConnectionEditor((self.__expressionAnalysisMode__ ? _getLocal(_scope10, 'connection', connection) : void 0, connection));
            }];
          }));
          let myConnectionsMenu = _getAndCallMember((self.__expressionAnalysisMode__ ? _traceMember(Connection, 'allConnectionsFor') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope, 'Connection', Connection) : void 0, Connection).allConnectionsFor(_getMember(this, 'source'))), 'map', [connection => {
            let _scope11 = {};
            return [(self.__expressionAnalysisMode__ ? _traceMember(connection, 'getLabel') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope11, 'connection', connection) : void 0, connection).getLabel()), () => {
              return self.__expressionAnalysisMode__ ? _traceMember(this, 'openConnectionEditor') : void 0, this.openConnectionEditor((self.__expressionAnalysisMode__ ? _getLocal(_scope11, 'connection', connection) : void 0, connection));
            }];
          }]);

          const menuItems = [['Value', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope8, 'evt', evt) : void 0, evt), 'value', false);
          }], ['Width', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope8, 'evt', evt) : void 0, evt), 'style.width', false);
          }], ['Height', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope8, 'evt', evt) : void 0, evt), 'style.height', false);
          }], ['Events', (self.__expressionAnalysisMode__ ? _traceMember(this, 'getAllEventsFor') : void 0, this.getAllEventsFor(_getMember(this, 'source'), (self.__expressionAnalysisMode__ ? _getLocal(_scope8, 'evt', evt) : void 0, evt)))], ['Style', (self.__expressionAnalysisMode__ ? _traceMember(this, 'getAllStylesFor') : void 0, this.getAllStylesFor(_getMember(this, 'source'), (self.__expressionAnalysisMode__ ? _getLocal(_scope8, 'evt', evt) : void 0, evt)))], ['On custom...', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionCustom') : void 0, this.startCreatingConnectionCustom((self.__expressionAnalysisMode__ ? _getLocal(_scope8, 'evt', evt) : void 0, evt));
          }], ['My Connections', (self.__expressionAnalysisMode__ ? _getLocal(_scope8, 'myConnectionsMenu', myConnectionsMenu) : void 0, myConnectionsMenu), '', '<i class="fa fa-arrow-right" aria-hidden="true"></i>'], ['All Connections', (self.__expressionAnalysisMode__ ? _getLocal(_scope8, 'existingConnectionsMenu', existingConnectionsMenu) : void 0, existingConnectionsMenu), '', '<i class="fa fa-arrow-right" aria-hidden="true"></i>']];

          if (self.__expressionAnalysisMode__) _traceMember(this, 'showMenu');
          this.showMenu((self.__expressionAnalysisMode__ ? _getLocal(_scope8, 'evt', evt) : void 0, evt), (self.__expressionAnalysisMode__ ? _getLocal(_scope8, 'menuItems', menuItems) : void 0, menuItems));
        }

        //More events https://developer.mozilla.org/en-US/docs/Web/Events
        getAllEventsFor(object, evt) {
          let _scope12 = {};

          return [['Click', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope12, 'evt', evt) : void 0, evt), 'click', true);
          }], ['DoubleClick', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope12, 'evt', evt) : void 0, evt), 'dblclick', true);
          }], ['MouseDown', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope12, 'evt', evt) : void 0, evt), 'mousedown', true);
          }], ['MouseEnter', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope12, 'evt', evt) : void 0, evt), 'mouseenter', true);
          }], ['MouseLeave', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope12, 'evt', evt) : void 0, evt), 'mouseleave', true);
          }], ['MouseMove', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope12, 'evt', evt) : void 0, evt), 'mousemove', true);
          }], ['MouseOver', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope12, 'evt', evt) : void 0, evt), 'mouseover', true);
          }], ['MouseOut', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope12, 'evt', evt) : void 0, evt), 'mouseout', true);
          }], ['MouseUp', () => {
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope12, 'evt', evt) : void 0, evt), 'mouseup', true);
          }]];
        }

        getAllStylesFor(object, evt, isFinishing = false) {
          let _scope13 = {};

          let result = [];
          let styles = (self.__expressionAnalysisMode__ ? _traceMember(window, 'getComputedStyle') : void 0, (self.__expressionAnalysisMode__ ? _getGlobal('window') : void 0, window).getComputedStyle((self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'object', object) : void 0, object)));
          let stylesLength = _getMember((self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'styles', styles) : void 0, styles), 'length');
          for (let i = 0; i < stylesLength; i++) {
            let _scope14 = {};

            if (self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'isFinishing', isFinishing) : void 0, isFinishing) {
              if (self.__expressionAnalysisMode__) _traceMember(result, 'push');

              (self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'result', result) : void 0, result).push([(self.__expressionAnalysisMode__ ? _traceMember(styles, 'item') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'styles', styles) : void 0, styles).item((self.__expressionAnalysisMode__ ? _getLocal(_scope14, 'i', i) : void 0, i))), event => {
                let _scope15 = {};
                return self.__expressionAnalysisMode__ ? _traceMember(this, 'finishCreatingConnection') : void 0, this.finishCreatingConnection((self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'object', object) : void 0, object), 'style.' + (self.__expressionAnalysisMode__ ? _traceMember(styles, 'item') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'styles', styles) : void 0, styles).item((self.__expressionAnalysisMode__ ? _getLocal(_scope14, 'i', i) : void 0, i))), (self.__expressionAnalysisMode__ ? _getLocal(_scope15, 'event', event) : void 0, event));
              }]);
            } else {
              if (self.__expressionAnalysisMode__) _traceMember(result, 'push');

              (self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'result', result) : void 0, result).push([(self.__expressionAnalysisMode__ ? _traceMember(styles, 'item') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'styles', styles) : void 0, styles).item((self.__expressionAnalysisMode__ ? _getLocal(_scope14, 'i', i) : void 0, i))), () => {
                return self.__expressionAnalysisMode__ ? _traceMember(this, 'startCreatingConnectionFor') : void 0, this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'evt', evt) : void 0, evt), 'style.' + (self.__expressionAnalysisMode__ ? _traceMember(styles, 'item') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'styles', styles) : void 0, styles).item((self.__expressionAnalysisMode__ ? _getLocal(_scope14, 'i', i) : void 0, i))), false);
              }]);
            }
          }
          return self.__expressionAnalysisMode__ ? _getLocal(_scope13, 'result', result) : void 0, result;
        }

        async showFinishingConnectorsMenuFor(evt, morph) {
          let _scope16 = {};

          const menuItems = [['Value', event => {
            let _scope17 = {};
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'finishCreatingConnection') : void 0, this.finishCreatingConnection((self.__expressionAnalysisMode__ ? _getLocal(_scope16, 'morph', morph) : void 0, morph), 'value', (self.__expressionAnalysisMode__ ? _getLocal(_scope17, 'event', event) : void 0, event));
          }], ['Width', event => {
            let _scope18 = {};
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'finishCreatingConnection') : void 0, this.finishCreatingConnection((self.__expressionAnalysisMode__ ? _getLocal(_scope16, 'morph', morph) : void 0, morph), 'style.width', (self.__expressionAnalysisMode__ ? _getLocal(_scope18, 'event', event) : void 0, event));
          }], ['Height', event => {
            let _scope19 = {};
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'finishCreatingConnection') : void 0, this.finishCreatingConnection((self.__expressionAnalysisMode__ ? _getLocal(_scope16, 'morph', morph) : void 0, morph), 'style.height', (self.__expressionAnalysisMode__ ? _getLocal(_scope19, 'event', event) : void 0, event));
          }], ['InnerHTML', event => {
            let _scope20 = {};
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'finishCreatingConnection') : void 0, this.finishCreatingConnection((self.__expressionAnalysisMode__ ? _getLocal(_scope16, 'morph', morph) : void 0, morph), 'innerHTML', (self.__expressionAnalysisMode__ ? _getLocal(_scope20, 'event', event) : void 0, event));
          }],
          // Hook for chained events
          //['Events', this.getAllEventsFor(morph, evt, true)],
          ['Style', (self.__expressionAnalysisMode__ ? _traceMember(this, 'getAllStylesFor') : void 0, this.getAllStylesFor((self.__expressionAnalysisMode__ ? _getLocal(_scope16, 'morph', morph) : void 0, morph), (self.__expressionAnalysisMode__ ? _getLocal(_scope16, 'evt', evt) : void 0, evt), true))], ['On custom...', event => {
            let _scope21 = {};
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'finishCreatingConnectionCustom') : void 0, this.finishCreatingConnectionCustom((self.__expressionAnalysisMode__ ? _getLocal(_scope16, 'morph', morph) : void 0, morph), (self.__expressionAnalysisMode__ ? _getLocal(_scope21, 'event', event) : void 0, event));
          }]];
          if (self.__expressionAnalysisMode__) _traceMember(this, 'showMenu');
          this.showMenu((self.__expressionAnalysisMode__ ? _getLocal(_scope16, 'evt', evt) : void 0, evt), (self.__expressionAnalysisMode__ ? _getLocal(_scope16, 'menuItems', menuItems) : void 0, menuItems));
        }

        elementUnderHand(evt) {
          let _scope22 = {};

          var path = _getAndCallMember((self.__expressionAnalysisMode__ ? _traceMember(evt, 'composedPath') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope22, 'evt', evt) : void 0, evt).composedPath()), 'slice', [_getAndCallMember((self.__expressionAnalysisMode__ ? _traceMember(evt, 'composedPath') : void 0, (self.__expressionAnalysisMode__ ? _getLocal(_scope22, 'evt', evt) : void 0, evt).composedPath()), 'indexOf', [_getMember((self.__expressionAnalysisMode__ ? _getLocal(_scope22, 'evt', evt) : void 0, evt), 'srcElement')])]);
          return _getMember((self.__expressionAnalysisMode__ ? _getLocal(_scope22, 'path', path) : void 0, path), 0);
        }

        onPointerMove(evt) {
          let _scope23 = {};

          if (_getMember(this, 'dropIndicator')) {
            _getAndCallMember(_getMember(this, 'dropIndicator'), 'remove', []);
          }_setMember(this, 'dropTarget', (self.__expressionAnalysisMode__ ? _traceMember(this, 'elementUnderHand') : void 0, this.elementUnderHand((self.__expressionAnalysisMode__ ? _getLocal(_scope23, 'evt', evt) : void 0, evt))));
          if (_getMember(this, 'dropTarget')) {
            _setMember(this, 'dropIndicator', (self.__expressionAnalysisMode__ ? _traceMember(lively, 'showElement') : void 0, (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).showElement(_getMember(this, 'dropTarget'))));
            _setMember(_getMember(_getMember(this, 'dropIndicator'), 'style'), 'border', "3px dashed rgba(0,100,0,0.5)");
            _setMember(_getMember(this, 'dropIndicator'), 'innerHTML', "");
          }

          if (_getMember(this, 'valueIndicator')) {
            _getAndCallMember(_getMember(this, 'valueIndicator'), 'remove', []);
          }_setMember(this, 'valueIndicator', _element('span', _attributes(), _children(_childExpression(_getMember(this, 'sourceProperty'))), {
            file: 'https://lively-kernel.org/lively4/lively4-function-completion/src/components/halo/lively-halo-connectors-item.js',
            end: {
              column: 60,
              line: 106
            },
            start: {
              column: 26,
              line: 106
            }
          }));
          _setMember(_getMember(_getMember(this, 'valueIndicator'), 'style'), 'zIndex', 200);
          if (self.__expressionAnalysisMode__) _traceMember(lively, 'setGlobalPosition');
          (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).setGlobalPosition(_getMember(this, 'valueIndicator'), (self.__expressionAnalysisMode__ ? _getLocal(_scope, 'pt', pt) : void 0, pt)(_getMember((self.__expressionAnalysisMode__ ? _traceMember(lively, 'getPosition') : void 0, (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).getPosition((self.__expressionAnalysisMode__ ? _getLocal(_scope23, 'evt', evt) : void 0, evt))), 'x') + 1, _getMember((self.__expressionAnalysisMode__ ? _traceMember(lively, 'getPosition') : void 0, (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).getPosition((self.__expressionAnalysisMode__ ? _getLocal(_scope23, 'evt', evt) : void 0, evt))), 'y') + 1));
          _getAndCallMember(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('document') : void 0, document), 'body'), 'appendChild', [_getMember(this, 'valueIndicator')]);
        }

        onPointerUp(evt) {
          let _scope24 = {};
          if (self.__expressionAnalysisMode__) _traceMember(lively, 'removeEventListener');

          (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).removeEventListener("Connectors");

          if (_getMember(this, 'dropIndicator')) {
            _getAndCallMember(_getMember(this, 'dropIndicator'), 'remove', []);
          }if (_getMember(this, 'valueIndicator')) {
            _getAndCallMember(_getMember(this, 'valueIndicator'), 'remove', []);
          }var morph = (self.__expressionAnalysisMode__ ? _traceMember(this, 'elementUnderHand') : void 0, this.elementUnderHand((self.__expressionAnalysisMode__ ? _getLocal(_scope24, 'evt', evt) : void 0, evt)));

          if (self.__expressionAnalysisMode__) _traceMember(this, 'showFinishingConnectorsMenuFor');
          this.showFinishingConnectorsMenuFor((self.__expressionAnalysisMode__ ? _getLocal(_scope24, 'evt', evt) : void 0, evt), (self.__expressionAnalysisMode__ ? _getLocal(_scope24, 'morph', morph) : void 0, morph));
        }

        async openConnectionEditor(connection) {
          let _scope25 = {};

          let editor = await (self.__expressionAnalysisMode__ ? _traceMember(lively, 'openComponentInWindow') : void 0, (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).openComponentInWindow('lively-connection-editor'));
          if (self.__expressionAnalysisMode__) _traceMember(editor, 'setConnection');
          (self.__expressionAnalysisMode__ ? _getLocal(_scope25, 'editor', editor) : void 0, editor).setConnection((self.__expressionAnalysisMode__ ? _getLocal(_scope25, 'connection', connection) : void 0, connection));
        }

        async startCreatingConnectionCustom(evt) {
          let _scope26 = {};

          var userinput = await (self.__expressionAnalysisMode__ ? _traceMember(lively, 'prompt') : void 0, (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).prompt("Enter something", "value"));
          if (self.__expressionAnalysisMode__) _traceMember(this, 'startCreatingConnectionFor');
          this.startCreatingConnectionFor((self.__expressionAnalysisMode__ ? _getLocal(_scope26, 'evt', evt) : void 0, evt), (self.__expressionAnalysisMode__ ? _getLocal(_scope26, 'userinput', userinput) : void 0, userinput), false);
        }

        startCreatingConnectionFor(evt, property, isEvent) {
          let _scope27 = {};

          _setMember(this, 'sourceProperty', (self.__expressionAnalysisMode__ ? _getLocal(_scope27, 'property', property) : void 0, property));
          _setMember(this, 'isEvent', (self.__expressionAnalysisMode__ ? _getLocal(_scope27, 'isEvent', isEvent) : void 0, isEvent));

          if (self.__expressionAnalysisMode__) _traceMember(lively, 'addEventListener');
          (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).addEventListener("Connectors", _getMember(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('document') : void 0, document), 'body'), 'parentElement'), "pointermove", e => {
            let _scope28 = {};
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'onPointerMove') : void 0, this.onPointerMove((self.__expressionAnalysisMode__ ? _getLocal(_scope28, 'e', e) : void 0, e));
          }, { capture: true });
          if (self.__expressionAnalysisMode__) _traceMember(lively, 'addEventListener');
          (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).addEventListener("Connectors", _getMember(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('document') : void 0, document), 'body'), 'parentElement'), "pointerup", e => {
            let _scope29 = {};
            return self.__expressionAnalysisMode__ ? _traceMember(this, 'onPointerUp') : void 0, this.onPointerUp((self.__expressionAnalysisMode__ ? _getLocal(_scope29, 'e', e) : void 0, e));
          }, { capture: true });
        }

        async finishCreatingConnectionCustom(target, event) {
          let _scope30 = {};

          var userinput = await (self.__expressionAnalysisMode__ ? _traceMember(lively, 'prompt') : void 0, (self.__expressionAnalysisMode__ ? _getGlobal('lively') : void 0, lively).prompt("Enter something", "style.width"));
          if (self.__expressionAnalysisMode__) _traceMember(this, 'finishCreatingConnection');
          this.finishCreatingConnection((self.__expressionAnalysisMode__ ? _getLocal(_scope30, 'target', target) : void 0, target), (self.__expressionAnalysisMode__ ? _getLocal(_scope30, 'userinput', userinput) : void 0, userinput), (self.__expressionAnalysisMode__ ? _getLocal(_scope30, 'event', event) : void 0, event));
        }

        finishCreatingConnection(target, targetProperty, event) {
          let _scope31 = {};

          let connection = new (self.__expressionAnalysisMode__ ? _getLocal(_scope, 'Connection', Connection) : void 0, Connection)((self.__expressionAnalysisMode__ ? _getLocal(_scope31, 'target', target) : void 0, target), (self.__expressionAnalysisMode__ ? _getLocal(_scope31, 'targetProperty', targetProperty) : void 0, targetProperty), _getMember(this, 'source'), _getMember(this, 'sourceProperty'), _getMember(this, 'isEvent'));
          if (self.__expressionAnalysisMode__) _traceMember(connection, 'activate');
          (self.__expressionAnalysisMode__ ? _getLocal(_scope31, 'connection', connection) : void 0, connection).activate();
          if (self.__expressionAnalysisMode__) _traceMember(connection, 'drawConnectionLine');
          (self.__expressionAnalysisMode__ ? _getLocal(_scope31, 'connection', connection) : void 0, connection).drawConnectionLine();
          if (!_getMember((self.__expressionAnalysisMode__ ? _getLocal(_scope31, 'event', event) : void 0, event), 'shiftKey')) {
            if (self.__expressionAnalysisMode__) _traceMember(this, 'openConnectionEditor');

            this.openConnectionEditor((self.__expressionAnalysisMode__ ? _getLocal(_scope31, 'connection', connection) : void 0, connection));
          }
        }
      }

      _export('default', LivelyHaloConnectorsItem);

      if (self.__expressionAnalysisMode__) _traceMember(Object, 'defineProperty');
      Object.defineProperty(_getMember((self.__expressionAnalysisMode__ ? _getGlobal('_recorder_') : void 0, _recorder_), '_src_components_halo_lively_halo_connectors_item_js'), 'LivelyHaloConnectorsItem', {
        get() {
          return self.__expressionAnalysisMode__ ? _getLocal(_scope, 'LivelyHaloConnectorsItem', LivelyHaloConnectorsItem) : void 0, LivelyHaloConnectorsItem;
        },

        set(thisIsVererySecretVariableName) {
          let _scope32 = {};
          _export('default', LivelyHaloConnectorsItem = (self.__expressionAnalysisMode__ ? _getLocal(_scope32, 'thisIsVererySecretVariableName', thisIsVererySecretVariableName) : void 0, thisIsVererySecretVariableName)), true ? _setLocal(_scope, 'LivelyHaloConnectorsItem', LivelyHaloConnectorsItem) : void 0, LivelyHaloConnectorsItem;
          return true;
        },

        enumerable: true,
        configurable: true
      });
    }
  };
});